#!/usr/bin/env python
#db.py
#Maintained by W.Yang
#
#An interface layer between database and handler.
#
#CVS Id $Id: db.py,v 1.21 2005/09/30 15:40:59 wy45 Exp $
import dbapi
import traceback
import exceptions
import pickle
import base64,sys

class DB:
   def __init__(self):
      
      self.open = False
   
   def OpenDB(self,hostname,user,password,dbname):
      try:
         self.conn = dbapi.DBConnection(hostname,user,password,dbname)
         result = 'successful'
         self.open = True
      except exceptions.Exception,e:
       #  print 'catch exception:%s' % str(e)
         result = 'DB exception: '+ str(e)
      return result
               
   def CloseDB(self):
      if self.open:
        try:
           self.conn.close()
           result = 'successful'
        except exceptions.Exception,e:
        #   print 'catch exception: %s' % str(e)
           result = 'DB exception: '+str(e)
      else:
          result = 'DB not open'
      return result
   
   def IsOpen(self):
      if self.open:
         return True
      else:
         return False
         
   def NewProject(self,projectName):
       if self.open:  
           # check whether project name exists
           sql1 = 'select * from projects where project_name = \''+self.conn.escape(str(projectName))+'\''
           result1 = ''
       
           try:
              self.conn.execute(sql1)
              result1 = self.conn.fetchall()
       
              if result1 == ():                   
                 # sql statement
                 sql = "insert into projects(project_name,start_date) values(\'"+self.conn.escape(str(projectName))+"\',now())"
                 try: 
                    #execute SQL statement
                    self.conn.execute(sql)
                    result = self.conn.insert_id()

                 except exceptions.Exception,e:
                    print 'catch exception:%s' % str(e)
                    result = 'DB exception: '+str(e)
                
              else:
                 result = 'Exist'

           except exceptions.Exception, e:
              result = 'DB exception: '+str(e)
       else:
          result = 'DB not open yet'
              
       return result

   def GetProject(self,projectName):
       if self.open:  
          # check whether project name exists
          sql1 = 'select project_id from projects where project_name = \''+self.conn.escape(str(projectName))+'\''
          resultset = ''
     
          try:
             self.conn.execute(sql1)
             resultset = self.conn.fetchall()
       
             if resultset == ():                   
                result = 'No Exist'
           
             else:
               #format the result
                result1 = resultset[0]
                result = str(result1[0])
                
          except exceptions.Exception, e:
             result = 'DB exception'+str(e)
       else:
          result = 'DB not open yet'

       return result

   def DeleteProject(self,projectname):
       if self.open:

          #check whether the project exist
          sele_pro_sql = "select * from projects where project_name=\'"+self.conn.escape(str(projectname))+"\'"
     
          try:
             self.conn.execute(sele_pro_sql)
             resultset = self.conn.fetchall()
             if resultset == ():
                result = 'No Exist'
             else:
                pro_id = self.GetProject(projectname)
                sele_job_sql = "select job_id from jobs where project_id = \'"+self.conn.escape(str(pro_id))+"\'"
                del_pro_sql = "delete from projects where project_name=\'"+self.conn.escape(str(projectname))+"\'"
                del_job_sql = "delete from jobs where project_id = \'"+self.conn.escape(str(pro_id))+"\'"
                
                self.conn.execute(sele_job_sql)
                jobids = self.conn.fetchall()
             
                if jobids != ():
                   for id in jobids:                      
                      dele_fact_sql = "delete from facts where job_id = \'"+self.conn.escape(str(id[0]))+"\'"
                      self.conn.execute(dele_fact_sql)
                      
                self.conn.execute(del_pro_sql)
                self.conn.execute(del_job_sql)
             
                result = 'Done'

          except exceptions.Exception, e:
             print str(e)
             result = 'DB exception '+str(e)
       else:
          result = 'DB not open yet'
       return result


   def GetJobid(self,projectname,jobname):
      if self.open:
         projectid = self.GetProject(projectname)
         if projectid != 'DB exception' and projectid != 'No Exist':
            sql = "select job_id from jobs where project_id = \'"+self.conn.escape(str(projectid))+"\' and job_name = \'"+self.conn.escape(str(jobname))+"\' order by start_date desc"
      
            try:
               self.conn.execute(sql)
               result1 = self.conn.fetchall()

               if result1 == ():
                  result = 'No such a job'
               else:
                  #format result
                  re = result1[0]
                  result = str(re[0])
            
            except exceptions.Exception,e:
               result = 'DB exception '+str(e)
         else:
            result = 'No such a project'
      else:
            result = 'DB not open yet'
      
      return result
                                                                           
   def NewJob(self,projectname,jobname):
      if self.open:
         projectid = self.GetProject(projectname)

         if projectid != 'DB exception' and projectid != 'No Exist':
            sql = "insert into jobs(project_id,job_name,start_date) values("+self.conn.escape(str(projectid))+",\'"+self.conn.escape(str(jobname))+"\',now())"
                
            try:
               #execute SQL statement
                self.conn.execute(sql)

               #result
                result = self.conn.insert_id()
           
            except exceptions.Exception, e:
       #         print 'catch exception: %s' % str(e)
                 result = 'DB exception: '+str(e)
         else:
            result = 'No such a project'
            
      else:
          result = 'DB not open yet'
      
      return result

   def GetJobname(self,jobid):
      if self.open:
         sql = "select job_name from jobs where job_id=" + self.conn.escape(str(jobid))
         try:
            self.conn.execute(sql)
            resultset = self.conn.fetchall()

            if resultset == ():
               result = 'Not such a job'
            else:
               result = str(resultset[0][0])
         except exceptions.Exception,e:
            result = 'DB exception: '+str(e)
      else:
         result = 'DB not open yet'

      return result
   
   def SetData(self,jobid,name,value):
       if self.open:
          #sql statement
          sql = "insert into facts (job_id,name,value) values("+self.conn.escape(str(jobid))+",\'"+self.conn.escape(str(name))+"\',\'"+self.conn.escape(str(value))+"\')"

          try:
             #execute SQL statement
             self.conn.execute(sql)

             #result
             result = self.conn.insert_id()
           
          except exceptions.Exception, e:
             #print 'catch exception: %s' % str(e)
              result = 'DB exception: '+str(e)
       else:
          result = 'DB not open yet'
          
       return result

   def GetData(self,jobid,name):
       if self.open:
         #sql statement
          sql = "select value from facts where job_id="+self.conn.escape(str(jobid))+" and name=\'"+self.conn.escape(str(name))+"\' order by fact_id desc"
          result = ''
       
          try:
             #execute SQL statement
             self.conn.execute(sql)
             # result 
             resultset = self.conn.fetchall()

             if resultset == ():
                result = 'Empty'
             else:                  
                #get the lastest one
             #   tmp = resultset[len(resultset)-1]
                tmp = resultset[0]
                result = str(tmp[0])         
             
          except exceptions.Exception, e:
      #       print 'catch exception: %s' % str(e)
             result = 'DB exception'+str(e)
       else:
          result = 'DB not open yet'
          
       return result

   def UpdateData(self,factid,value):
      if self.open:
         sql = "update facts set value= \'"+self.conn.escape(str(value))+"\' where fact_id = "+self.conn.escape(str(factid))
         
         try:
            #execute SQL statement
            self.conn.execute(sql)
            result = 'Done'
            
         except exceptions.Exception,e:
            result = 'DB exception'+str(e)

      else:
         result = 'DB not open yet'

      return result

   def ImportDingbat(self,jobid,name,description,type,value):
       if self.open:
          sql = "insert into dingbats (job_id,name,description,type,value) values("+self.conn.escape(str(jobid))+",\'"+self.conn.escape(str(name))+"\',\'"+self.conn.escape(str(description))+"\',\'"+self.conn.escape(str(type))+"\',\'"+ self.conn.escape(str(value))+"\')"
       
          try:
              self.conn.execute(sql)
              result = self.conn.insert_id()
              result = str(result)
          except exceptions.Exception,e:
     
              result = 'DB exception: '+str(e)
       else:
          result = 'DB not open yet'
          
       return result

   def ExportDingbat(self,jobid,name):
      if self.open:
          #sql statement
          sql = "select value from dingbats where job_id="+self.conn.escape(str(jobid))+" and name=\'"+self.conn.escape(str(name))+"\' order by dingbat_id"
          result = ''
       
          try:
             #execute SQL statement
             self.conn.execute(sql)
             # result 
             resultset = self.conn.fetchall()
      
             if resultset == ():
                result = 'Empty'
             else:
                #get the last one in tuple
               # tmp = resultset[len(resultset)-1]
                tmp = resultset[0]
                result = str(tmp[0])
              
          except exceptions.Exception, e:
   
             result = 'DB exception: '+str(e)
      else:
          result = 'DB not open yet'
          
      return result

   def DeleteDingbat(self,jobid,name):
       if self.open:
          sql = "delete from dingbats where job_id="+self.conn.escape(str(jobid))+" and name=\'"+self.conn.escape(str(name))+"\'"
       
          try:
             self.conn.execute(sql)
             result = 'Done'
             
          except exceptions.Exception, e:
         #    print 'catch exception: %s' % str(e)
             result = 'DB exception: '+str(e)
       else:
          result = 'DB not open yet'
       return result

   def DescribeDingbat(self,jobid,name):
       if self.open:
          sql = "select description,type from dingbats where job_id="+self.conn.escape(str(jobid))+" and name=\'"+self.conn.escape(str(name))+"\'"
          result = ''
   
          try:
             #execute SQL statement
             self.conn.execute(sql)
             # result 
             resultset = self.conn.fetchall()

             if resultset == ():
                result = 'Empty'
             else:
                #get the last one in tuple
                tmp = resultset[len(resultset)-1]
                result = str(tmp[0])
                
          except exceptions.Exception, e:
               result = 'DB exception: '+str(e)
       else:
          result = 'DB not open yet'
       return result
           
   def ListProjects(self):
       #sql statement
       sql = "select * from projects order by project_id"
       result = ''
       if self.open:
          try:
             #execute sql
             self.conn.execute(sql)

             #result
             result = self.conn.fetchall()

             if result == ():
                result = 'Empty'

          except exceptions.Exception,e:      
             result = 'DB exception: '+str(e)
 
       else:
          result = 'DB not open yet'
       return result


   def ListJobs(self,projectname):
      if self.open:
             projectid = self.GetProject(projectname)
             if projectid != 'DB exception' and projectid != 'No Exist':
                #sql statement
                sql = "select * from jobs where project_id ="+self.conn.escape(str(projectid))+" order by job_id"
                result = ''
   
                try:
                  #execute sql  
                  self.conn.execute(sql)

                  #result 
                  result = self.conn.fetchall()

                  if result == ():
                     result = 'Empty'
              
                except exceptions.Exception,e:
                    result='DB exception:' +str(e) 
             else:
                     result = 'No Exist'     
      else:
         result = 'DB not open yet'
      
          
      return result

   def ListItems(self,jobid):
       if self.open:
           #sql statement
          sql = "select name,value,epoch from facts where job_id = "+self.conn.escape(str(jobid))+" order by fact_id"
          result=''
   
          try:
            #execute sql
             self.conn.execute(sql)

            #result
             result = self.conn.fetchall()

             if result == ():
                 result = 'Empty'
          
          except exceptions.Exception, e: 
             result = 'DB exception:' +str(e) 
       else:
          result = 'DB not open yet'
          
       return result

    
   def Version(self):
      try:
           result = str(dbapi.Version())
      except exceptions.Exception, e:
         result = 'DB exception: '+str(e) 

      return result
